summaryrefslogtreecommitdiff
path: root/plugins/transfer/transfer.plugin.zsh
diff options
context:
space:
mode:
authorKozlov Alexander <badryke@gmail.com>2018-11-16 13:38:43 +0300
committerGitHub <noreply@github.com>2018-11-16 13:38:43 +0300
commit8c95c52353118643ac3dbd9b0c185a3129b84bf8 (patch)
treeee7497251b7a541480ae5c6a97b63b14381ed5ee /plugins/transfer/transfer.plugin.zsh
parentdd30cf104c9ca42d89d26a134382ca421869ce7e (diff)
parent3d8f2bda599c8c6d160dc448e5ab28aaf2d5e90d (diff)
downloadzsh-8c95c52353118643ac3dbd9b0c185a3129b84bf8.tar.gz
zsh-8c95c52353118643ac3dbd9b0c185a3129b84bf8.tar.bz2
zsh-8c95c52353118643ac3dbd9b0c185a3129b84bf8.zip
Merge branch 'master' into master
Diffstat (limited to 'plugins/transfer/transfer.plugin.zsh')
-rw-r--r--plugins/transfer/transfer.plugin.zsh67
1 files changed, 67 insertions, 0 deletions
diff --git a/plugins/transfer/transfer.plugin.zsh b/plugins/transfer/transfer.plugin.zsh
new file mode 100644
index 000000000..7a7cd85ec
--- /dev/null
+++ b/plugins/transfer/transfer.plugin.zsh
@@ -0,0 +1,67 @@
+# transfer.sh Easy file sharing from the command line
+# transfer Plugin
+# Usage Example :
+# > transfer file.txt
+# > transfer directory/
+
+
+
+# Author:
+# Remco Verhoef <remco@dutchcoders.io>
+# https://gist.github.com/nl5887/a511f172d3fb3cd0e42d
+# Modified to use tar command instead of zip
+#
+
+curl --version 2>&1 > /dev/null
+if [ $? -ne 0 ]; then
+ echo "Could not find curl."
+ return 1
+fi
+
+transfer() {
+ # check arguments
+ if [ $# -eq 0 ];
+ then
+ echo "No arguments specified. Usage:\necho transfer /tmp/test.md\ncat /tmp/test.md | transfer test.md"
+ return 1
+ fi
+
+ # get temporarily filename, output is written to this file show progress can be showed
+ tmpfile=$( mktemp -t transferXXX )
+
+ # upload stdin or file
+ file=$1
+
+ if tty -s;
+ then
+ basefile=$(basename "$file" | sed -e 's/[^a-zA-Z0-9._-]/-/g')
+
+ if [ ! -e $file ];
+ then
+ echo "File $file doesn't exists."
+ return 1
+ fi
+
+ if [ -d $file ];
+ then
+ echo $file
+ # tar directory and transfer
+ tarfile=$( mktemp -t transferXXX.tar.gz )
+ cd $(dirname $file) && tar -czf $tarfile $(basename $file)
+ curl --progress-bar --upload-file "$tarfile" "https://transfer.sh/$basefile.tar.gz" >> $tmpfile
+ rm -f $tarfile
+ else
+ # transfer file
+ curl --progress-bar --upload-file "$file" "https://transfer.sh/$basefile" >> $tmpfile
+ fi
+ else
+ # transfer pipe
+ curl --progress-bar --upload-file "-" "https://transfer.sh/$file" >> $tmpfile
+ fi
+
+ # cat output link
+ cat $tmpfile
+
+ # cleanup
+ rm -f $tmpfile
+} \ No newline at end of file